#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for(int j = 0; j < (m); ++j)

typedef long long ll;
typedef long double ld;
typedef vector<int> vint;
typedef vector<vector<int> > vvint;
typedef vector<ll> vll;
typedef vector<vector<ll> > vvll;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const double PI = acos(-1);
const ll INF = 1e18;

vector<vector<int> > g;
vector<int> cnt;

void dfs(int v, int path = 0){
    cnt[path]++;
    for (int to : g[v])
        dfs(to, path + 1);
}

void solve(){
    int n;
    cin >> n;
    g.resize(n);
    cnt.resize(n + 1);
    for (int i = 0; i < n - 1; ++i){
        int p;
        cin >> p;
        p--;
        g[p].push_back(i + 1);
    }
    dfs(0);
    int res = 0;
    for (int i = 0; i < cnt.size(); ++i)
        res += cnt[i] % 2;
    cout << res;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifndef ONLINE_JUDGE
    freopen("input.in", "r", stdin);
    //freopen("output.out", "w", stdout);
#endif
    solve();
#ifndef ONLINE_JUDGE
    //cerr << fixed << setprecision(6) << (ld)clock() / CLOCKS_PER_SEC << '\n';
#endif
    return 0;
}

