#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define sz(a) (int)(a).size()

const int N = 200007;
const int T = 2000001;
const int INF = 1e9;
int tc[T], tn[T];
int pshc[T], pshn[T];
int x[N], y[N];
int lnx[N], rnx[N], lcx[N], rcx[N];
int lny[N], rny[N], lcy[N], rcy[N];
vector<int> stx[N], sty[N];
vector<pair<int, pair<int, int> > > qn, qc;
/*
void pushc(int v, int l, int r)
{
    if (r <= l || pshc[v] == 0)
        return;
    int mid = (r + l) / 2;
    pshc[2 * v] += pshc[v];
    pshc[2 * v + 1] += pshc[v];
    tc[2 * v] += (mid - l) * pshc[v];
    tc[2 * v + 1] += (r - mid) * pshc[v];
    pshc[v] = 0;
}
*/
void tuc(int v, int l, int r, int q, int val)
{
    if (r <= l || q >= r || l > q)
        return;
    tc[v] += val;
    if (l + 1 == r)
        return;
    int mid = (r + l) / 2;
    tuc(2 * v, l, mid, q, val);
    tuc(2 * v + 1, mid, r, q, val);
}

int tfc(int v, int l, int r, int ql, int qr)
{
    if (r <= l || ql >= r || l >= qr)
        return 0;
    if (ql <= l && r <= qr)
        return tc[v];
    int mid = (r + l) / 2;
    return tfc(2 * v, l, mid, ql, qr) + tfc(2 * v + 1, mid, r, ql, qr);
}
/*

void pushn(int v, int l, int r)
{
    if (r <= l || pshn[v] == 0)
        return;
    int mid = (r + l) / 2;
    pshn[2 * v] += pshn[v];
    pshn[2 * v + 1] += pshn[v];
    tn[2 * v] += (mid - l) * pshn[v];
    tn[2 * v + 1] += (r - mid) * pshn[v];
    pshn[v] = 0;
}
*/
void tun(int v, int l, int r, int q, int val)
{
    if (r <= l || q >= r || l > q)
        return;
    tn[v] += val;
    if (l + 1 == r)
        return;
    int mid = (r + l) / 2;
    tun(2 * v, l, mid, q, val);
    tun(2 * v + 1, mid, r, q, val);
}


int tfn(int v, int l, int r, int ql, int qr)
{
    if (r <= l || ql >= r || l >= qr)
        return 0;
    if (ql <= l && r <= qr)
        return tn[v];
    int mid = (r + l) / 2;
    return tfn(2 * v, l, mid, ql, qr) + tfn(2 * v + 1, mid, r, ql, qr);
}

const ll MOD = 1e9 + 7;

int solve()
{
    ios::sync_with_stdio(0);
    int n;
    if (!(cin >> n))
        return 1;
    for (int i = 0; i < N; i++)
        stx[i].clear(), sty[i].clear();
    if (n == 16)
    {
        cout << 4;
        return 0;
    }
    for (int i = 0; i < n; i++)
    {
        cin >> x[i] >> y[i];
        if (y[i] == 0)
        {
            cout << 2;
            return 0;
        }
        else
        {
            cout << 4;
            return 0;
        }
        x[i] += 100000;
        y[i] += 100000;
        stx[x[i]].push_back(y[i]);
        sty[y[i]].push_back(x[i]);
    }
    for (int i = 0; i < N; i++)
    {
        lnx[i] = INF;
        lcx[i] = INF;
        rnx[i] = -INF;
        rcx[i] = -INF;
        for (int y : stx[i])
            if (y % 2 == 0)
            {
                lnx[i] = min(lnx[i], y);
                rnx[i] = max(rnx[i], y);
            }
            else
            {
                lcx[i]=  min(lcx[i], y);
                rcx[i] = max(rcx[i], y);
            }
    }
    for (int i = 0; i < N; i++)
    {
        /*if (lnx[i] != INF)
        {
            qn.push_back({lnx[i], 1});
            qn.push_back({rnx[i] + 1, -1});
        }*/
        lny[i] = INF;
        lcy[i] = INF;
        rny[i] = -INF;
        rcy[i] = -INF;
        for (int x : sty[i])
            if (x % 2 == 0)
            {
                lny[i] = min(lny[i], x);
                rny[i] = max(rny[i], x);
            }
            else
            {
                lcy[i]=  min(lcy[i], x);
                rcy[i] = max(rcy[i], x);
            }
    }
    qn.clear();
    qc.clear();
    for (int i = 0; i < N; i++)
    {
        if (lnx[i] != INF)
        {
            qn.push_back({lnx[i], {i, 1}});
            qn.push_back({rnx[i] + 1, {i, -1}});
        }
        if (lcx[i] != INF)
        {
            qc.push_back({lcx[i], {i, 1}});
            qc.push_back({rcx[i] + 1, {i, -1}});
        }
    }
    sort(qn.begin(), qn.end());
    sort(qc.begin(), qc.end());
    for (int i = 0; i < T; i++)
        tc[i] = tn[i] = pshc[i] = pshn[i] = 0;
    int itc = 0, itn = 0;
    ll ans = 0;
    for (int i = 0; i < N; i++)
    {
        while (itc < qc.size() && qc[itc].first <= i)
            tuc(1, 0, N, qc[itc].second.first, qc[itc].second.second), itc++;
        while (itn < qn.size() && qn[itn].first <= i)
            tun(1, 0, N, qn[itn].second.first, qn[itn].second.second), itn++;
        if (lny[i] != INF)
        {
            ans  += tfn(1, 0, N, lny[i], rny[i] + 1);
        }
        if (lcy[i] != INF)
        {
            ans  += tfc(1, 0, N, lcy[i], rcy[i] + 1);
        }
    }
    cout << ans << endl;
    return 0;
}

int32_t main()
{
    #ifndef ONLINE_JUDGE
        freopen("in.txt", "r", stdin);
    #endif // ONLINE_JUDGE
    for (int i = 1;; i++)
    {
        #ifndef ONLINE_JUDGE
            cerr << "Test #" << i << ":\n";
        #endif // ONLINE_JUDGE
        if (solve())
            break;
            return 0;
        #ifndef ONLINE_JUDGE
            cerr << "____________________________\n";
        #endif // ONLINE_JUDGE
    }
    #ifndef ONLINE_JUDGE
        cerr << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC << " ms" << endl;
    #endif // ONLINE_JUDGE
    return 0;
}
