#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int) 1e9;

int main() {
    #ifdef MY
        freopen("in.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(NULL);
    #endif // MY
    int n;
    cin >> n;
    vector<ll> a(n);
    ll sum = 0;
    for (auto &x : a) {
        cin >> x;
        sum += x;
    }
    sort(a.begin(), a.end());
    vector<ll> has;
    ll cnt[3] = {0, 0, 0};
    for (int i = 0; i < n; ++i) {
        if (has.empty() || has.back() != a[i]) {
            has.push_back(a[i]);
        }
        cnt[(int) has.size() - 1]++;
    }
    if (has.size() < 3) {
        cout << n << "\n";
        for (int i = 0; i < n; ++i) {
            cout << a[i] << " ";
        }
        cout << "\n";
    } else {
        ll best = n;
        ll num1 = -1, num2 = -1;
        for (ll num = 0; num <= n; ++num) {
            ll here = num * has[0];
            ll l = -1, r = n - num;
            while (l < r - 1) {
                ll m = (l + r) / 2;
                if (here + m * has[1] + (n - num - m) * has[2] >= sum) {
                    l = m;
                } else {
                    r = m;
                }
            }
            if (r >= 0 && n - num - r >= 0 && sum == here + r * has[1] + (n - num - r) * has[2]) {
                ll mst = min(cnt[0], num) + min(cnt[1], r) + min(cnt[2], n - num - r);
                if (mst < best) {
                    best = mst;
                    num1 = num;
                    num2 = r;
                }
            }
        }
        cout << best << "\n";
        if (best == n) {
            for (int i = 0; i < n; ++i) {
                cout << a[i] << " ";
            }
            cout << "\n";
        } else {
            for (int i = 0; i < num1; ++i) {
                cout << has[0] << " ";
            }
            for (int i = 0; i < num2; ++i) {
                cout << has[1] << " ";
            }
            for (int i = 0; i < n - num1 - num2; ++i) {
                cout << has[2] << " ";
            }
            cout << "\n";
        }
    }
    return 0;
}
