#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int) 1e9;

enum {
    OPEN, ASK, CLOSE
};

struct E {
    int x, t;

    bool operator<(const E &a) const {
        return x < a.x || x == a.x && t < a.t;
    }
};

int main() {
    #ifdef MY
        freopen("in.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(NULL);
    #endif // MY
    int n, m;
    cin >> n >> m;
    vector<E> es;
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        es.push_back({l, OPEN});
        es.push_back({r, CLOSE});
    }
    for (int i = 0; i < m; ++i) {
        es.push_back({i, ASK});
    }
    sort(es.begin(), es.end());
    vector<int> a(m);
    int cnt = 0;
    for (auto e : es) {
        if (e.t == OPEN) {
            ++cnt;
        } else if (e.t == ASK) {
            a[e.x] = cnt;
        } else {
            --cnt;
        }
    }
    vector<vector<int>> dp(2, vector<int> (m, 0));
    for (int k = 0; k < 2; ++k) {
        vector<int> len(m + 1, INF);
        len[0] = -1;
        for (int i = 0; i < m; ++i) {
            int p = upper_bound(len.begin(), len.end(), a[i]) - len.begin();
//            cout << i << " " << p << "\n";
            len[p] = min(len[p], a[i]);
            dp[k][i] = p;
        }
        reverse(a.begin(), a.end());
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        ans = max(ans, dp[0][i] + dp[1][m - i - 1] - 1);
    }
    cout << ans << "\n";
//    for (int i = 0; i < m; ++i) {
//        cout << a[i] << " ";
//    }
//    cout << "\n";
//    for (int k = 0; k < 2; ++k) {
//        for (int i = 0; i < m; ++i) {
//            cout << dp[k][(k ? m - i - 1 : i)] << " ";
//        }
//        cout << "\n";
//    }
    return 0;
}
