#pragma warning(disable : 4996)

#include<iostream>
#include<vector>
#include<cstring>
#include<algorithm>
#include<set>
#include<map>
using namespace std;

#define ll long long int
#define setv(dgioj, redgs) memset(dgioj, redgs, sizeof(dgioj))
#define all(dgioj) dgioj.begin(), dgioj.end()

const int N = 1e5 +100, INF = 1e9;
int sum[N], t[2][N * 4], up[2][N * 4];
int n, m;

void push(int g, int v, int l, int r) {
	if (up[g][v]) {
		if (l != r) {
			up[g][v * 2] += up[g][v];
			up[g][v * 2 + 1] += up[g][v];
		}
		t[g][v] += up[g][v];
		up[g][v] = 0; 
	}
}

void upd(int x, int d, int g, int v = 1, int L = 0, int R = n) {
	push(g, v, L, R);
	if (x < L || x > R)
		return;
	if (L == R)
		t[g][v] = min(t[g][v], d);
	else {
		int m = (L + R) >> 1;
		upd(x, d, g, v * 2, L, m);
		upd(x, d, g, v * 2 + 1, m + 1, R);
		t[g][v] = min(t[g][v * 2], t[g][v * 2 + 1]);
	}
}


void rupd(int l, int r, int g, int v = 1, int L = 0, int R = n) {
	push(g, v, L, R);
	if (l > r)
		return;
	if (L == l && r == R) {
		up[g][v]++;
		push(g, v, l, r);
	}
	else {
		int m = (L + R) >> 1;
		rupd(l, min(m ,r), g, v * 2, L, m);
		rupd(max(m + 1, l), r, g, v * 2 + 1, m + 1, R);
		t[g][v] = min(t[g][v * 2], t[g][v * 2 + 1]);
	}
}
int que(int l, int r, int g, int v = 1, int L = 0, int R = n) {
	push(g, v, L, R);
	if (l > r)
		return INF;
	if (l == L && r == R)
		return t[g][v];
	int m = (L + R) >> 1;
	return min(que(l, min(m, r), g, v * 2, L, m),
		que(max(m + 1, l), r, g, v* 2 + 1, m + 1, R));
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &n, &m);

	for (int i = 0; i < n; i++) {
		int l, r;
		scanf("%d%d", &l, &r);
		l--, r--;
		sum[l]++;
		sum[r + 1]--;
	}

	for (int i = 1; i<= m; i++)
		sum[i] += sum[i - 1];

	setv(t, 63);
	upd(0, 0, 0);

	for (int i = 0; i < m; i++) {
		int a = que(0, sum[i], 0),
			b = min(que(sum[i], n, 0), que(sum[i], n, 1));
		rupd(0, n, 0);
		rupd(0, n, 1);
		upd(sum[i], a, 0);
		upd(sum[i], b, 1);
	}

	printf("%d", m - min(que(0, n, 0), que(0, n, 1)));



	
	return 0;
}