#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
using namespace std;

// **  ** *****   ***** *    * ***  *   * *  *  * * 
// **  ** *           * *    * *  * *  ** *  *  * *
// ****** *****   ***** **** * ***  * * * *  *  * ***
//     ** *           * *  * * *    **  * *  *  * *  *
//     ** *****   ***** **** * *    *   * ******* ***

const int len = 2e5;
int x, y;
int l[len], r[len];
int add[len];
int v[len];

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> x >> y;
	for(int i = 0;i < x;i++){
		cin >> l[i] >> r[i];
		--l[i];
		--r[i];
		add[l[i]]++;
		add[r[i] + 1]--;
	}
	int now = 0;
	for(int i = 0;i < y;i++){
		now += add[i];
		v[i] = now;
	}
#ifdef _DEBUG
	for(int i = 0;i < y;i++)
		cout << v[i] << ' ';
	cout << endl;
#endif
	
	vector < int > dl(y, 0), dr(y, 0);

	vector < int > dp(y + 1, 1 << 30);

	for(int i = 0;i < y;i++){
		int l = -1, r = dp.size() - 1;
		while(r - l > 1){
			int m = l + r >> 1;
			if(dp[m] > v[i])
				r = m;
			else
				l = m;
		}
		dp[r] = v[i];
		dl[i] = r + 1;
	}

	for(int i = 0;i < dp.size();i++)
		dp[i] = 1 << 30;

	for(int i = y - 1;i >= 0;i--){
		int l = -1, r = dp.size() - 1;
		while(r - l > 1){
			int m = l + r >> 1;
			if(dp[m] > v[i])
				r = m;
			else
				l = m;
		}
		dp[r] = v[i];
		dr[i] = r + 1;
	}

#ifdef _DEBUG
	for(int i = 0;i < y;i++){
		cout << dl[i] << ' ';
	}
	cout << endl;
	for(int i = 0;i < y;i++){
		cout << dr[i] << ' ';
	}
	cout << endl;
#endif

	int ans = 0;
	for(int i = 0;i < y;i++){
		ans = max(ans, dl[i] + dr[i] - 1);
	}
	cout << ans;

#ifdef _DEBUG
	cout << "\n\n\nTIME: " << clock();
#endif
}