#include <bits/stdc++.h>

using namespace std;

bool get(vector<int> &prefMax, vector<int> &sufMax, vector<int> &field, int pos) {
    return field[pos] < prefMax[pos] && field[pos] < sufMax[pos];
}

const int INF = 1e9;

int main() {
    int n, m;
    cin >> n >> m;
    vector<int> field(m + 1, 0);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        field[l]++;
        field[r]--;
    }
    int now = 0;
    for (int i = 0; i < m; ++i) {
        now += field[i];
        field[i] = now;
    }
    vector<int> dp(m + 1, INF), f(m + 1, INF), s(m + 1, INF);
    dp[0] = 0;
    for (int i = 0; i < m; ++i) {
        int num = field[i];
        int pos = upper_bound(dp.begin(), dp.end(), num) - dp.begin();
//        for (auto x: dp) {
//            cout << x << " ";
//        }
//        cout << "\n";
        dp[pos] = min(dp[pos], num);
        f[i] = pos;
    }
    vector<int> dp2(m + 1, INF);
    dp2[0] = 0;
    for (int i = m - 1; i >= 0; --i) {
        int num = field[i];
        int pos = upper_bound(dp2.begin(), dp2.end(), num) - dp2.begin();
        dp2[pos] = min(dp2[pos], num);
        s[i] = pos;
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        ans = max(ans, s[i] + f[i] - 1);
    }
    cout << ans << "\n";
}
