/*
    Program by T1rex a.k.a Hrumka
    Olympiad: Technocup 2018 final.
    Date 04.03.2018.
    All copyrights reserved.
*/
#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define pp pop_back

#define F first
#define S second
#define FF F.F
#define FS F.S
#define SF S.F
#define SS S.S

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ldb;

typedef pair < int, int > pii;
typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;

const int inf = 1e9;
const ll INF = 1e18;
const int mod = 1e9 + 7;
const int MAXN = (int)1e6 + 228;
const double eps = 1e-6;
const double pi = acos (-1.0);

int n;
int x[MAXN];
int Min = inf, Max = -inf, mn;
int k[10];

void out_x () {
    cout << n << endl;
    for (int i = 1; i <= n; ++i) cout << x[i] << ' ';
    exit (0);
}

void sol1(int sz) {
    cout << sz << endl;
  //  cout << "here" << endl;
    for (int i = 1; i <= mn; ++i) {--k[1]; --k[3]; ++k[2]; ++k[2];}
    for (int i = 1; i <= k[1]; ++i) cout << Min << ' ';
    for (int i = 1; i <= k[2]; ++i) cout << 1 + Min << ' ';
    for (int i = 1; i <= k[3]; ++i) cout << Max << ' ';
}

void sol2 () {
    cout << k[1] + k[3] + bool (k[2] & 1) << endl;


    while (2 <= k[2]) {++k[1]; ++k[3]; --k[2]; --k[2];}
    for (int i = 1; i <= k[1]; ++i) cout << Min << ' ';
    for (int i = 1; i <= k[2]; ++i) cout << 1 + Min << ' ';
    for (int i = 1; i <= k[3]; ++i) cout << Max << ' ';
}

int main () {
    ios_base :: sync_with_stdio (false);
    cin.tie (NULL); cout.tie (NULL);
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> x[i];
    Min = *min_element (x + 1, x + n + 1);
    Max = *max_element (x + 1, x + n + 1);
    if (Min == Max || abs (Min - Max) == 1) out_x ();
    for (int i = 1; i <= n; ++i) {
        if (!(x[i] - Min)) k[1]++;
        else if (x[i] == Max) ++k[3];
        else ++k[2];
    }
   /// cout << "ok" << endl;
    //cout << k[1] << ' ' << k[2] << ' ' << k[3] << endl;
    mn = min (k[1], k[3]);
    //cnt[2] + (max(cnt[1], cnt[3]) - min(cnt[1], cnt[3])) < cnt[1] + cnt[3] + cnt[2] % 2
    int result1 = max (k[1], k[3]) - min (k[1], k[3]) + k[2];
    int result2 = k[1] + bool (k[2] & 1) + k[3];
    if (result1 < result2)
        sol1 (result1);
    else
        sol2 ();
    //cerr << "Time elapsed: " << (clock () + 0.) / CLOCKS_PER_SEC;
    return 0;
}