/*
    Program by T1rex a.k.a Hrumka
    Olympiad: Technocup 2018 final.
    Date 04.03.2018.
    All copyrights reserved.
*/
#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define pp pop_back

#define F first
#define S second
#define FF F.F
#define FS F.S
#define SF S.F
#define SS S.S

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ldb;

typedef pair < int, int > pii;
typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;

const int inf = 1e9;
const ll INF = 1e18;
const int mod = 1e9 + 7;
const int MAXN = (int)1e6 + 228;
const double eps = 1e-6;
const double pi = acos (-1.0);

string s;
int n;
ll one[30][6000], cnt[30][30][6000];
ll sum;

int main () {
    ios_base :: sync_with_stdio (false);
    cin.tie (NULL); cout.tie (NULL);
    cin >> s;
    int n = (int)s.size();
    for (int i = 0; i < n; ++i) {
        string cur = "";
        for (int j = i; j < n; ++j) cur += s[j];
        for (int j = 0; j < i; ++j) cur += s[j];
        char c = cur[0];
        for (int j = 0; j < n; ++j) ++cnt[c - 'a'][cur[j] - 'a'][j];
    }
    for (int i = 0; i < n; ++i) {
        string cur = "";
        for (int j = i; j < n; ++j) cur += s[j];
        for (int j = 0; j < i; ++j) cur += s[j];
        char c = cur[0];
        for (int j = 0; j < n; ++j)
            if (!(cnt[c - 'a'][cur[j] - 'a'][j] - 1)) ++one[c - 'a'][j];  
    }
    for (char c = 'a'; c <= 'z'; ++c) {
        ll cur = 0;   
        for (int i = 0; i < n; ++i) cur = max (cur, one[c - 'a'][i]);
        sum += cur;    
    }
    cout << fixed << setprecision (10) << (1.0 * sum) / (1. * n);
    //cerr << "Time elapsed: " << (clock () + 0.) / CLOCKS_PER_SEC;
    return 0;
}