#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < b; ++i)

int debug = 0;

const int N = 1<<18;
int ans, op[N], cl[N], t[N << 1];

void update(int v) {
    v += N - 1;
    t[v]++;
    while (v) {
        v = (v - 1) / 2;
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

}

int get(int l, int r) {
    if (l > r) { return 0; }
    l += N - 1, r += N - 1;
    int res = 0;
    while (l < r) {
        if (l % 2 == 0) res += t[l];
        if (r % 2 == 1) res += t[r];
        l = l / 2;
        r = (r - 2) / 2;
    }
    if (l == r) res += t[l];
    return res;
}

main() {
    int n, m;
    cin >> n >> m;
    rep(i,0,n) {
        int l, r;
        scanf("%d%d", &l, &r);
        op[l]++;
        cl[r]++;
    }
    vector <vector<int>> pos(n + 2);
    int bal = 0;
    rep(i, 1, m + 1) {
        bal += op[i];
        pos[bal].push_back(i);
        bal -= cl[i];
    }
    rep(i, 0, n + 1) {
        int mx = 0, cnt = 0;
        for (int j : pos[i]) {
            cnt++;
            ans = max(ans, mx + cnt + get(j+1,m));
            mx = max(mx, get(0,j-1) - (cnt - 1));
            if (debug) {
                cerr << j << ' ' << i << ' ' << cnt << ' ' << mx << " get = " << get(0,j-1) << endl;
            }
        }
        for (int j : pos[i]) update(j);
    }
    cout << ans << endl;
    return 0;
}
