#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < b; ++i)

int debug = 0;

const int N = 1<<18;
int ans, op[N], cl[N], t[N << 1], pr[N], sf[N];

void update(int v, int dd) {
    v += N - 1;
    t[v] = dd;
    while (v) {
        v = (v - 1) / 2;
        t[v] = max(t[v * 2 + 1] , t[v * 2 + 2]);
    }

}

int get(int l, int r) {
    if (l > r) { return 0; }
    l += N - 1, r += N - 1;
    int res = 0;
    while (l < r) {
        if (l % 2 == 0) res = max(res, t[l]);
        if (r % 2 == 1) res = max(res, t[r]);
        l = l / 2;
        r = (r - 2) / 2;
    }
    if (l == r) res = max(res, t[l]);
    return res;
}

main() {
    int n, m;
    cin >> n >> m;
    rep(i,0,n) {
        int l, r;
        scanf("%d%d", &l, &r);
        op[l]++;
        cl[r]++;
    }
    int bal = 0;
    vector <int> p(m + 2, 0);
    vector <vector<int>>ord(n+2);
    rep(i, 1, m + 1) {
        bal += op[i];
        p[i] = bal;
        ord[p[i]].push_back(i);
        bal -= cl[i];
    }
    //sort(ord.begin(), ord.end());
    rep(i, 0, n + 1) {
        sort(ord[i].begin(), ord[i].end());
        for (int j : ord[i]) {
            pr[j] = get(0,j-1) + 1;
            update(j,pr[j]);
        }
    }
    fill(t, t + N + N, 0);
    rep(i, 0, n + 1) {
        reverse(ord[i].begin(), ord[i].end());
        for (int j : ord[i]) {
            sf[i] = get(j + 1, m) + 1;
            update(j, sf[j]);
        }
    }
    ans = 0;
    rep(i, 0, m + 1) {
        ans = max(ans, pr[i] + sf[i + 1]);
        if (debug) { cerr << " i= " << i << ' ' << pr[i] << ' ' << sf[i + 1] << endl; }
    }
    cout << ans << endl;
    return 0;
}
