#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <ctime>

using namespace std;
const int MAXN = 1e5 + 100;

int ur[MAXN];
int n;
vector<int> g[MAXN];
int p[MAXN];

void dfs(int v, int d){
    ur[d] += 1;
    for (auto e : g[v]){
        dfs(e, d + 1);
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;

    for (int i = 1; i < n; ++i){
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }

    dfs(0, 0);

    int ans = 0;
    for (int i = 0; i < MAXN; ++i){
        ans += ur[i] % 2;
    }

    cout << ans << endl;

    return 0;
}
