#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <ctime>

using namespace std;
const int MAXN = 5e3 + 100;
const int ALPHA = 26;
const int INF = 1e9 + 100;

int n;
long double nl;
string str;
int mas[ALPHA][MAXN][ALPHA];
long double mmx[ALPHA];
map<char, long double> mp;
set<char> st;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    fill(mmx, mmx + ALPHA, 0);
    for (int i = 0; i < ALPHA; ++i){

        for (int j = 0; j < MAXN; ++j){
            fill(mas[i][j], mas[i][j] + ALPHA, 0);
        }
    }

    cin >> str;
    n = str.size();
    nl = n;

    for (auto e : str){
        mp[e - 'a'] += 1 / nl;
    }

    str = str + str;

    for (int i = 0; i < n; ++i){
        for (int j = i; j - i < n; ++j){
            mas[str[i] - 'a'][j - i][str[j] - 'a']++;
        }
    }

    for (int i = 0; i < ALPHA; ++i){
        for (int j = 0; j < n; ++j){
            long double sm = 0;
            long double ce = 0;
            for (int l = 0; l < ALPHA; ++l){
                if (mas[i][j][l] == 1) ce += 1;
                sm += mas[i][j][l];
            }
            mmx[i] = max(mmx[i], ce / sm);
        }
    }

    long double ans = 0;

    for (int i = 0; i < ALPHA; ++i){
        ans += mmx[i] * mp[i];
    }

    cout.precision(30);
    cout << ans << endl;

    return 0;
}
