#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))
#define sqr(x) ((x)*(x))

ll rnd() {
    ll res = rand();
    res = (res << 16) + rand();
    return res;
}

ll logn(ll n) {
    ll xx = ll(log2(ld(n)));
    if (pw(xx) != n) ++xx;
    return xx;
}

struct Sparse {
    vector<vll> t;

    void build(vll &a) {
        ll n = a.size();
        t.resize(logn(n) + 1);
        t[0] = a;
        for (int i = 1; i < t.size(); ++i) {
            t[i].resize(n - pw(i) + 1);
            for (int j = 0; j < t[i].size(); ++j) {
                t[i][j] = min(t[i - 1][j], t[i - 1][j + pw(i - 1)]);
            }
        }
    }

    ll Min(ll l, ll r) {
        if (l > r) swap(l, r);
        ll xx = logn(r - l + 1);
        ll f1 = t[xx][l], f2 = t[xx][r - pw(xx) + 1];
        return min(f1, f2);
    }

    void print() {
        for (int i = 0; i < t.size(); ++i) {
            for (int j = 0; j < t[i].size();++j) cout << t[i][j] << ' ';
            cout << '\n';
        }
    }
};

int source() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    sort(all(a));
    if (a.back() == a[0]) {
        vll aa;
        for (int i = 0; i < n / 2; ++i) aa.push_back(a[0] - 1);
        for (int i = 0; i < n / 2; ++i) aa.push_back(a[0] + 1);
        if (n & 1) aa.push_back(a[0]);
        sort(all(a));
        cout << (n & 1) << '\n';
        sort(all(aa));
        for (int i = 0; i < n; ++i) cout << aa[i] << ' ';
        return 0;
    }
    if (a.back() - a[0] < 2) {
        cout << n << '\n';
        for (int i = 0; i < n; ++i) cout << a[i] << ' ';
        return 0;
    }
    ll x1 = a[0], x2 = a.back();
    ll kol1 = 0;
    vll b1, a1 = a;
    for (int i =0 ; i < a1.size(); ++i) {
        if (i == a1.size() - 1) {
            b1.push_back(a1[i]);
            kol1++;
            continue;
        }
        if (a1[i] + 2 == a1.back()) {
            b1.push_back(a1[i] + 1);
            b1.push_back(a1[i] + 1);
            a1.pop_back();
            continue;
        }
        b1.push_back(a1[i]);
        kol1++;
    }
    vll b2, a2 = a;
    ll kol2 = 0;
    while (a2.size() && a2.back() == x2) {
        kol2++;
        b2.push_back(a2.back());
        a2.pop_back();
    }
    for (int i = 0; i < a2.size(); ++i) {
        if (a2[i] == x1) {
            kol2++;
            b2.push_back(a2[i]);
            continue;
        }
        if (i + 1 == a2.size()) {
            kol2++;
            b2.push_back(a2[i]);
            continue;
        }
        b2.push_back(x1);
        b2.push_back(x2);
        ++i;
    }
    if (kol1 < kol2) {
        cout << kol1 << '\n';
        sort(all(b1));
        for (int i = 0; i < n; ++i) cout << b1[i] << ' ';
    } else {

        cout << kol2 << '\n';
        sort(all(b2));
        for (int i = 0; i < n; ++i) cout << b2[i] << ' ';
    }
    return 0;
}

int main() {
#ifdef aokigahara
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // aokigahara

    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    source();
#ifdef aokigahara
    cerr << "\n\nTIME : " << fixed << setprecision(12) << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}

