#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))
#define sqr(x) ((x)*(x))

ll rnd() {
    ll res = rand();
    res = (res << 16) + rand();
    return res;
}

ll logn(ll n) {
    ll xx = ll(log2(ld(n)));
    if (pw(xx) != n) ++xx;
    return xx;
}

struct Sparse {
    vector<vll> t;

    void build(vll &a) {
        ll n = a.size();
        t.resize(logn(n) + 1);
        t[0] = a;
        for (int i = 1; i < t.size(); ++i) {
            t[i].resize(n - pw(i) + 1);
            for (int j = 0; j < t[i].size(); ++j) {
                t[i][j] = min(t[i - 1][j], t[i - 1][j + pw(i - 1)]);
            }
        }
    }

    ll Min(ll l, ll r) {
        if (l > r) swap(l, r);
        ll xx = logn(r - l + 1);
        ll f1 = t[xx][l], f2 = t[xx][r - pw(xx) + 1];
        return min(f1, f2);
    }

    void print() {
        for (int i = 0; i < t.size(); ++i) {
            for (int j = 0; j < t[i].size();++j) cout << t[i][j] << ' ';
            cout << '\n';
        }
    }
};


int source() {
    string s;
    cin >> s;
    ll n = s.size();
    vector<string> a;
    string tmp = s;
    for (int i = 0; i < n; ++i) {
        a.push_back(tmp);
        char x = tmp[0];
        for (int j = 0; j < n - 1; ++j) tmp[j] = tmp[j + 1];
        tmp[n - 1] = x;
    }
    sort(all(a));
    ll kol = 0;
    ll r = 0, l = 0;
    while (l != n) {
        while (r < n && a[r][0] == a[l][0]) ++r;
        //cerr << l << ' ' << r << '\n';
        if (r - l  == 1) {
            kol++;
            l = r;
            continue;
        }
        ll tmpans = 0;
        for (int i = 0; i < n;++i) {
            vll co(26, 0);
            ll aa = 0;
            for (int j = l; j < r; ++j) co[a[j][i] - 'a']++;
            for (int k = 0; k < 26; ++k) {
                if (co[k] == 1) aa++;
            }
            tmpans = max(tmpans, aa);
        }
        kol += tmpans;
        l = r;
    }
    //cerr << kol;
    cout << fixed << setprecision(12) << ld(kol) / ld(n);
    return 0;
}

int main() {
#ifdef aokigahara
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // aokigahara

    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    source();
#ifdef aokigahara
    cerr << "\n\nTIME : " << fixed << setprecision(12) << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}
