#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define endl '\n'
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (int i = 0; i < (int)arr.size() - 1; ++i)
        out << arr[i] << " ";
    if (arr.back())
        out << arr.back();
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

signed main()
{
    int n;
    cin >> n;
    vector <int> arr(n);
    cin >> arr;
    int mn = 1000000000;
    for (auto x : arr)
        mn = min(mn, x);
    for (auto & x : arr)
        x -= mn;
    vector <int> pod(3);
    for (auto x : arr)
        pod[x]++;
    if (pod[2] == 0) {
        cout << n << endl;
        for (int i = 0; i < n; ++i) {
            cout << mn + arr[i] << " ";
        }
        cout << endl;
        return 0;
    }

    int sum = pod[1] + 2 * pod[2];
    vector <int> pod2(3);
    vector <int> best = pod;
    int best_val = n;
    for (int i = 0; i <= n; ++i) {
        pod2[1] = i;
        if (i > sum)
            break;
        if ((sum - i) % 2 != 0) {
            continue;
        }
        pod2[2] = (sum - i) / 2;
        pod2[0] = n - pod2[2] - pod2[1];
        if (pod2[0] < 0)
            continue;
        if (min(pod2[0], pod[0]) + min(pod2[1], pod[1]) + min(pod2[2], pod[2]) < best_val) {
            best_val = min(pod2[0], pod[0]) + min(pod2[1], pod[1]) + min(pod2[2], pod[2]);
            best = pod2;
        }
    }
    cout << best_val << endl;
    for (int i = 0; i < best[0]; ++i) {
        cout << mn  << " ";
    }
    for (int i = 0; i < best[1]; ++i) {
        cout << mn + 1 << " ";
    }
    for (int i = 0; i < best[2]; ++i) {
        cout << mn + 2 << " ";
    }
    cout << endl;
    return 0;
}
