#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define endl '\n'
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (int i = 0; i < (int)arr.size() - 1; ++i)
        out << arr[i] << " ";
    if (arr.back())
        out << arr.back();
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

vector <vector <int> > g;
vector <int> h;

void dfs(int v, int hn = 0, int p = -1) {
    h[hn]++;
    for (auto x : g[v]) {
        if (x == p)
            continue;
        dfs(x, hn + 1, v);
    }
}

signed main()
{
    int n;
    cin >> n;
    g.resize(n);
    h.resize(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int p;
        cin >> p;
        --p;
        g[i + 1].push_back(p);
        g[p].push_back(i + 1);
    }
    dfs(0);
    int ans = 0;
    for (auto x : h)
        ans += x % 2;
    cout << ans << endl;
    return 0;
}
