#include <bits/stdc++.h>

using namespace std;

//#define int int64_t
#define endl '\n'
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (int i = 0; i < (int)arr.size() - 1; ++i)
        out << arr[i] << " ";
    if (arr.size())
        out << arr.back() << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

const int INF = 1000000000;

vector <int> get(vector <int> arr) {
    int n = arr.size();
    vector <int> dp(n + 1, INF);
    dp[0] = -INF;
    vector <int> ans(n + 1);
    ans[0] = 0;
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        auto it = upper_bound(dp.begin(), dp.end(), arr[i]);
        if (it == dp.end())
            continue;
        dp[it - dp.begin()] = arr[i];
        mx = max(mx, it - dp.begin());
        ans[i + 1] = mx;
    }
    return ans;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector <pair <int, int> > otr(n);
    cin >> otr;
    vector <pair <int, int> > op;
    for (auto x : otr)
    {
        op.push_back(mp(x.fi - 1, 1));
        op.push_back(mp(x.se, -1));
    }
    for (int i = 0; i < m; ++i)
        op.push_back(mp(i, 10));
    sort(op.begin(), op.end());
    vector <int> cnt;
    int bal = 0;
    for (auto x : op) {
        if (x.se == 1) {
            bal++;
        }
        else if (x.se == -1) {
            bal--;
        }
        else {
            cnt.push_back(bal);
        }
    }
    //cout << "cnt = " << cnt << endl;
    auto p1 = get(cnt);
    reverse(cnt.begin(), cnt.end());
    auto p2 = get(cnt);
    //cout << "p1 = " << p1 << endl;
    //cout << "p2 = " << p2 << endl;
    int ans = 0;
    for (int i = 0; i <= m; ++i) {
        ans = max(ans, p1[i] + p2[m - i]);
    }
    cout << ans << endl;
    return 0;
}


