#include <bits/stdc++.h>
using namespace std;

int n, m;
vector<int> st, arr;
vector<int> dp;
vector<int> fr, t;

void update(int v, int tl, int tr, int pos, int val)
{
	if(tl == tr)
	{
		t[v] = max(t[v], val);
	} else
	{
		int tm = (tl + tr) / 2;
		if(pos <= tm)
		{
			update(2 * v + 1, tl, tm, pos, val);
		} else
		{
			update(2 * v + 2, tm + 1, tr, pos, val);
		}
		t[v] = max(t[2 * v + 1], t[2 * v + 2]);
	}
}

int get(int v, int tl, int tr, int l, int r)
{
	if(l > r)
	{
		return 0;
	} else if(tl == l && tr == r)
	{
		return t[v];
	} else
	{
		int tm = (tl + tr) / 2;
		return max(get(2 * v + 1, tl, tm, l, min(tm, r)), get(2 * v + 2, tm + 1, tr, max(tm + 1, l), r));
	}	
}

int main (int argc, char *argv[])
{
	scanf("%d%d", &n, &m);	
	st.resize(m + 1, 0);
	for(int i = 0; i < n; ++i)
	{
		int a, b;
		scanf("%d%d", &a, &b);
		--a;
		st[a]++;
		st[b]--;
	}
	arr.resize(m);
	for(int i = 0, cur = 0; i < m; ++i)
	{
		cur += st[i];
		arr[i] = cur;
	}

	dp.resize(m + 1, int(2e9));
	dp[0] = -1;
	fr.resize(m);
	for(int i = 0; i < m; ++i)
	{
		int l = 0,
			r = m;
		while(l != r)
		{
			int mid = (l + r) / 2 + (l + r) % 2;
			if(dp[mid] <= arr[i])
			{
				l = mid;
			} else
			{
				r = mid - 1;
			}
		}
		fr[i] = l + 1;
		dp[l + 1] = min(dp[l + 1], arr[i]);
	}
	t.resize(4 * (n + 5), -1);
	update(0, 0, n + 4, n + 4, 0);
	int ans = 0;
	for(int i = 0; i < m; ++i)
	{
		int u = get(0, 0, n + 4, arr[i], n + 4);
		int cur_ans = max(fr[i], u + 1);
		ans = max(ans, cur_ans);
		update(0, 0, n + 4, arr[i], cur_ans);
	}
	printf("%d", ans);

	return 0;
}

