#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second

const int maxn = 1e5 + 10;
const ll inf = 1e18;

ll nvp[2][maxn];
ll dp[2][maxn];
ll cnt[2][maxn];

vector<pair<int, int> > mas;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        mas.push_back({l, r});
    }
    sort(mas.begin(), mas.end());
    multiset<int> open;
    int it = 0;
    for (int i = 1; i <= m; ++i) {
        while (it < mas.size() && mas[it].x <= i) {
            open.insert(mas[it].y);
            it++;
        }

        while (!open.empty() && *open.begin() < i) {
            open.erase(open.find(*open.begin()));
        }
        cnt[0][i] = open.size();
        cnt[1][m - i + 1] = open.size();
    }

    for (int i = 0; i < maxn; ++i) {
        for (int j = 0; j < 2; ++j) {
            nvp[j][i] = inf;
            dp[j][i] = 0;
        }
    }

    /*for (int i = 1; i <= m; ++i) {
        cout << i << ' ' << cnt[0][i] << ' ' << cnt[1][i] << endl;
    }*/

    for (int i = 0; i < 2; ++i) {
        nvp[i][0] = -1;
        for (int j = 1; j <= m; ++j) {
            int l = 0, r = n + 1;
            while (l + 1 < r) {
                int M = (l + r) / 2;
                if (nvp[i][M] > cnt[i][j])
                    r = M;
                else
                    l = M;
            }

            nvp[i][l + 1] = min(nvp[i][l + 1], cnt[i][j]);
            if (!i)
                dp[i][j] = max(dp[i][j - 1], (ll)l + 1);
            else
                dp[i][j + 1] = max(dp[i][j - 1], (ll)l + 1);
        }
    }

    ll ans = 0;
    for (int i = 1; i <= m; ++i) {
        ans = max(ans, dp[0][i] + dp[1][m - i + 1]);
    }

    cout << ans << endl;
    return 0;
}
