#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

#define int int64_t

const int INF = 1e9;
const int MAXN = 2e5;

int x[MAXN];

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int n; cin >> n;
    int xmin = INF, xmax = -INF;
    for (int i = 0; i < n; i++) {
        cin >> x[i];
        xmin = min(xmin, x[i]);
        xmax = max(xmax, x[i]);
    }

    if (xmin + 2 != xmax) {
        cout << n << endl;
        for (int i = 0; i < n; i++)
            cout << x[i] << " ";
        cout << endl;
        return 0;
    }

    int c1 = 0, c2 = 0, c3 = 0;
    for (int i = 0; i < n; i++) {
        if (x[i] == xmin)
            c1++;
        if (x[i] == xmin + 1)
            c2++;
        if (x[i] == xmin + 2)
            c3++;
    }

    int res = n, res1 = c1, res2 = c2, res3 = c3;
    for (int add = -n; add <= n; add++) {
        int a1 = c1 + add, a3 = c3 + add, a2 = n - a1 - a3;
        if (a1 >= 0 && a1 <= n && a2 >= 0 && a2 <= n && a3 >= 0 && a3 <= n && xmin * a1 + (xmin + 1) * a2 + (xmin + 2) * a3 == xmin * c1 + (xmin + 1) * c2 + (xmin + 2) * c3) {
            int cur = min(a1, c1) + min(a2, c2) + min(a3, c3);
            if (cur < res)
                res = cur, res1 = a1, res2 = a2, res3 = a3;
        }
    }

    cout << res << endl;
    for (int i = 0; i < res1; i++)
        cout << xmin << " ";
    for (int i = 0; i < res2; i++)
        cout << xmin + 1 << " ";
    for (int i = 0; i < res3; i++)
        cout << xmin + 2 << " ";
    cout << endl;

    return 0;
}
