#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

#define int int64_t

const int SZ = 'z' - 'a' + 1;

const int MAXN = 1e4;

int d[SZ][SZ][MAXN];
int cnt[SZ];

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    string s; cin >> s;
    int n = (int)s.length();
    for (int i = 0; i < n; i++)
        cnt[s[i] - 'a']++;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            d[s[i] - 'a'][s[j] - 'a'][(j - i + n) % n]++;

    int res = 0;
    for (int i = 0; i < SZ; i++) {
        int w = 0;
        for (int j = 0; j < (int)n; j++) {
            int wins = 0;
            for (int c = 0; c < SZ; c++)
                if (d[i][c][j] == 1)
                    wins++;
            w = max(w, wins);
        }
        res += w;
    }

    cout.precision(40);

    cout << (double)res / (double)n << endl;

    return 0;
}
