#include<iostream>
#include<string>
#include<math.h>
#include<vector>
#include<algorithm>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<time.h>

using namespace std;

/*
Дорога к топу
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
														^(0,0)^ ^(0,0)^ ^(0,0)^
													^(0,0)^ ^(0,0)^ ^(0,0)^
												^(0,0)^ ^(0,0)^ ^(0,0)^
											^(0,0)^ ^(0,0)^ ^(0,0)^
										^(0,0)^ ^(0,0)^ ^(0,0)^
									^(0,0)^ ^(0,0)^ ^(0,0)^
								^(0,0)^ ^(0,0)^ ^(0,0)^
							^(0,0)^ ^(0,0)^ ^(0,0)^
						^(0,0)^ ^(0,0)^ ^(0,0)^
					^(0,0)^ ^(0,0)^ ^(0,0)^
				^(0,0)^ ^(0,0)^ ^(0,0)^
			^(0,0)^ ^(0,0)^ ^(0,0)^
		^(0,0)^ ^(0,0)^ ^(0,0)^
	^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^

*/

const int maxn = 2e5 + 113;

bool used[maxn];
int ans[maxn];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.precision(12);
	cout.setf(ios::fixed);
	int n, m;
	cin >> n >> m;
	vector<pair<int,int>> q;
	for(int i = 0; i < n; i++)
	{
		int a, b;
		cin >> a >> b;
		q.push_back(make_pair(a, i));
		q.push_back(make_pair(b + 1, i));
	}
	sort(q.begin(), q.end());
	reverse(q.begin(), q.end());
	int v = 0;
	int maw = 0;
	for(int i = 1; i <= m; i++)
	{
		while(q.size() && q.back().first == i)
		{
			if(!used[q.back().second])
				used[q.back().second] = 1, v++;
			else
				v--;
			q.pop_back();
		}
		ans[i] = v;
		maw = max(maw, v);
	}
	long long anso = 0;
	int left = 0;
	int l = 0, r = 0;
	vector<pair<int,int>> t;
	for(int i = 1; i <= m; i++)
	{
		l = i;
		while(i <= m && ans[i] <= ans[i + 1])
			i++;
		while(i <= m && ans[i] >= ans[i + 1])
			i++;
		r = i;
		t.push_back(make_pair(l, r));
	}
	cout << m - ((int)t.size() - 1);
}
