#include<iostream>
#include<string>
#include<math.h>
#include<vector>
#include<algorithm>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<time.h>

using namespace std;

/*
Дорога к топу
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
														^(0,0)^ ^(0,0)^ ^(0,0)^
													^(0,0)^ ^(0,0)^ ^(0,0)^
												^(0,0)^ ^(0,0)^ ^(0,0)^
											^(0,0)^ ^(0,0)^ ^(0,0)^
										^(0,0)^ ^(0,0)^ ^(0,0)^
									^(0,0)^ ^(0,0)^ ^(0,0)^
								^(0,0)^ ^(0,0)^ ^(0,0)^
							^(0,0)^ ^(0,0)^ ^(0,0)^
						^(0,0)^ ^(0,0)^ ^(0,0)^
					^(0,0)^ ^(0,0)^ ^(0,0)^
				^(0,0)^ ^(0,0)^ ^(0,0)^
			^(0,0)^ ^(0,0)^ ^(0,0)^
		^(0,0)^ ^(0,0)^ ^(0,0)^
	^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^

*/

const int maxn = 2e5 + 113;

bool used[maxn];
int ans[maxn];
long long dp1[maxn];
long long dp2[maxn];

struct tree{
	int x;
	tree* left;
	tree* right;
	tree()
	{
		this->x = 0;
		this->left = nullptr;
		this->right = nullptr;
	}
};

struct DO{
	tree* root;
	DO()
	{
		root = new tree();
	}
	void push(tree* root, int l, int r)
	{
		if(l >= r)
			return;
		if(root->left == nullptr)
			root->left = new tree();
		if(root->right == nullptr)
			root->right = new tree();
	}

	void upd(tree* root, int l, int r, int v, int x)
	{
		if(l > r || l > v || r < v)
			return;
		push(root, l, r);
		if(l == v && r == v)
		{
			root->x = x;
			return;
		} 
		int m = (l + r) / 2;
		upd(root->left, l, m, v, x);
		upd(root->right, m + 1, r, v, x);
		root->x = max(root->left->x, root->right->x);
	}

	long long masw(tree* root, int l, int r, int l1, int r1)
	{
		if(l > r || l1 > r || r1 < l)
			return 0;
		push(root, l, r);
		if(l == l1 && r == r1)
			return root->x;
		int m = (l + r) / 2;
		long long x1 = masw(root->left, l, m, l1, min(m, r1));
		long long x2 = masw(root->right, m + 1, r, max(m + 1, l1), r1);
		return max(x1, x2);
	}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.precision(12);
	cout.setf(ios::fixed);
	int n, m;
	cin >> n >> m;
	vector<pair<int,int>> q;
	for(int i = 0; i < n; i++)
	{
		int a, b;
		cin >> a >> b;
		q.push_back(make_pair(a, i));
		q.push_back(make_pair(b + 1, i));
	}
	sort(q.begin(), q.end());
	reverse(q.begin(), q.end());
	int v = 0;
	int maw = 0;
	for(int i = 1; i <= m; i++)
	{
		while(q.size() && q.back().first == i)
		{
			if(!used[q.back().second])
				used[q.back().second] = 1, v++;
			else
				v--;
			q.pop_back();
		}
		ans[i] = v;
		maw = max(maw, v);
	}
	long long anso = 0;
	int l = 0, r = 0;
	DO s1, s2;
	for(int i = 1; i <= m; i++)
	{
		long long t = s1.masw(s1.root, 0, n + 1, 0, ans[i]);
		dp1[i] = t + 1;
		s1.upd(s1.root, 0, m, ans[i], dp1[i]);
	}
	for(int i = m; i >= 1; i--)
	{
		long long t = s2.masw(s2.root, 0, n + 1, 0, ans[i]);
		dp2[i] = t + 1;
		s2.upd(s2.root, 0, m, ans[i], dp2[i]);
	}
	for(int i = 1; i <= m; i++)
		anso = max(anso, dp1[i] + dp2[i] - 1);
	cout << anso;
}
