#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define pii pair <int, int>
#define endl '\n'
//#define int long long

using namespace std;

const int mod = 1e9 + 7;
const int N = 1e5 + 5;

int cnt[N], reversecnt[N], pref[N], suff[N], ispref[N], issuff[N], anspref[N], anssuff[N];
int dp[N];
int cursz = 0;

int bin(int x) {
    int l = 0, r = cursz - 1;
    int res = -1;
    while (l <= r) {
        int mid = (l + r) / 2;
        if (dp[mid] > x) {
            res = mid;
            r = mid - 1;
        } else l = mid + 1;
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        cnt[l]++;
        cnt[r + 1]--;
        if (l > 1) reversecnt[l - 1]--;
        reversecnt[r]++;
    }
    int cur = 0;
    for (int i = 1; i <= m; i++) cur += cnt[i], pref[i - 1] = cur;
    cur = 0;
    for (int i = m; i >= 1; i--) cur += reversecnt[i], suff[i - 1] += cur;
    reverse(suff, suff + m);
    for (int i = 0; i < m; i++) dp[i] = 1e9;
    dp[0] = pref[0], anspref[0] = 1, ispref[0] = 1;
    cursz = 1;
    for (int i = 1; i < m; i++) {
        if (pref[i] >= dp[cursz - 1]) {
            dp[cursz] = pref[i];
            anspref[i] = ++cursz;
            ispref[i] = 1;
            continue;
        }
        {
            int pos = bin(pref[i]);
            dp[pos] = pref[i];
            anspref[i] = cursz;
        }
    }
    for (int i = 0; i < m; i++) dp[i] = 1e9;
    dp[0] = suff[0], anssuff[0] = 1, issuff[0] = 1;
    cursz = 1;
    for (int i = 1; i < m; i++) {
        if (suff[i] >= dp[cursz - 1]) {
            dp[cursz] = suff[i];
            anssuff[i] = ++cursz;
            issuff[i] = 1;
            continue;
        }
        {
            int pos = bin(suff[i]);
            dp[pos] = suff[i];
            anssuff[i] = cursz;
        }
    }
    int res = 0;
    for (int i = 0; i < m; i++) {
        int cur = anspref[i] + anssuff[m - i - 1];
      //  cout << anspref[i] << " " << anssuff[m - i - 1] << " " << ispref[i]  << " " << issuff[m - i - 1] << endl;
        if (ispref[i] && issuff[m - i - 1]) cur--;
        res = max(res, cur);
    }
    cout << res << endl;
    return 0;
}
