#include <bits/stdc++.h>
#include <windows.h>

using namespace std;

const int INF = 1001001001;

int n, m;
int cnt[100005];
int dpL[100005], lenL[100005];
int dpR[100005], lenR[100005];

void calcDP(int *dp, int *len) {
	dp[0] = -INF;
	len[0] = 0;
	for(int i = 1; i <= m; ++i)
		dp[i] = INF;
	for(int i = 1; i <= m; ++i) {
		int j = upper_bound(dp, dp + n + 1, cnt[i]) - dp;
		if(j <= m) {
			dp[j] = cnt[i];
			len[i] = max(len[i - 1], j);
		}
	}
}

int main() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif

	cin >> n >> m;

	int l, r;
	for(int i = 0; i < n; ++i) {
		cin >> l >> r;
		cnt[l] += 1;
		cnt[r + 1] -= 1;
	}

	int cur = 0;
	for(int i = 1; i <= m; ++i) {
		cur += cnt[i];
		cnt[i] = cur;
	}

	calcDP(dpL, lenL);

	for(int i = m; i > m / 2; --i)
		swap(cnt[i], cnt[m - i + 1]);

	calcDP(dpR, lenR);

	int res = 0;
	for(int i = 0; i < m; ++i)
		res = max(res, lenL[i] + lenR[m - i]);

	cout << res;
}
