#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define mp make_pair
#define f first
#define s second

const int MAXN = 1e5 + 5;
int n, m;
vector<int> a;
vector<pair<int, bool>> ev; // 0 - open
vector<int> p1, p2;

int get(int h, const vector<int> &dp) {
	int l = 0, r = dp.size() - 1;
	while (r - l > 1) {
		int m = l + (r - l) / 2;
		if (dp[m] > h) r = m;
		else l = m;
	}
	return l;
}

vector<int> get_nvp(vector<int> a, bool rev) {
	if (rev) reverse(a.begin(), a.end());
	int n = a.size();
	vector<int> dp(n + 2, INT_MAX);
	vector<int> ans(n);
	dp[0] = -1;

	for (int i = 0; i < n; ++i) {
		int h = get(a[i], dp);
		ans[i] = h + 1;
		dp[h + 1] = min(dp[h + 1], a[i]);
	}

	if (rev) reverse(ans.begin(), ans.end());
	return ans;
}

int main() {
	cin >> n >> m;
	a.resize(m);
	ev.resize(n * 2 + 1);
	rep(i, n) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		ev[i * 2] = {l, 0};
		ev[i * 2 + 1] = {r, 1};
	}
	ev[n * 2] = {INT_MAX, 1};
	sort(ev.begin(), ev.end());
	reverse(ev.begin(), ev.end());

	// cout << endl;
	// rep(i, ev.size()) {
	// 	cout << ev[i].f << ' ' << ev[i].s << endl;
	// }

	int h = 0;
	rep(i, m) {
		auto last = ev.back();
		while (last.f == i && last.s == 0) {
			h++;
			ev.pop_back();
			last = ev.back();
		}
		a[i] = h;
		last = ev.back();
		while (last.f == i && last.s == 1) {
			h--;
			ev.pop_back();
			last = ev.back();
		}
	}

	p1 = get_nvp(a, false);
	p2 = get_nvp(a, true);

	int ans = 0;
	rep(i, m) {
		ans = max(ans, p1[i] + p2[i] - 1);
	}
	cout << ans << endl;
}