#include<bits/stdc++.h>
#define int long long
#define pb push_back
#define F first
#define S second
#define ld long double

using namespace std;
const int N = 2e5;
int pi[N], a[N], dp[N * 4], suf[N];

void up(int now, int l, int r, int x, int add)
{
    if(l == r)
    {
        dp[now] = add;
        return;
    }
    int mid = (l + r) / 2;
    if(x <= mid)
    {
        up(now * 2, l, mid, x, add);
    }
    else
    {
        up(now * 2 + 1, mid + 1, r, x, add);
    }
    dp[now] = max(dp[now * 2], dp[now * 2 + 1]);
}

int get(int now, int l, int r, int b, int e)
{
    if(l == b && r == e)
    {
        return dp[now];
    }
    if(b > e)
    {
        return 0;
    }
    int mid = (l + r) / 2;
    return max(get(now * 2, l, mid, b, min(mid, e)), get(now * 2 + 1, mid + 1, r, max(mid + 1, b), e));
}

inline void solve()
{
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++)
    {
        int l, r;
        cin >> l >> r;
        l--;
        pi[l]++;
        pi[r]--;
    }
    int now = 0;
    for(int i = 0; i < m; i++)
    {
        now += pi[i];
        a[i] = now;
    }
    for(int i = m - 1; i >= 0; i--)
    {
        suf[i] = suf[i + 1] + (a[i] == 0);
    }
    int ans = 0;
    for(int i = 0; i < m; i++)
    {
        now += pi[i];
        a[i] = now;
        up(1, 0, n, a[i], get(1, 0, n, 0, a[i]) + 1);
        ans = max(ans, get(1, 0, n, 0, n) + suf[i + 1]);
    }
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
