#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for(int j = 0; j < (m); ++j)

typedef long long ll;
typedef long double ld;
typedef vector<int> vint;
typedef vector<vector<int> > vvint;
typedef vector<ll> vll;
typedef vector<vector<ll> > vvll;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const double PI = acos(-1);
const ll INF = 1e18;

void solve(){
    int n;
    cin >> n;
    vll x(n);
    for(int i = 0; i < n; ++i)
        cin >> x[i];
    sort(x.begin(), x.end());
    vll cnt;
    vll val;
    forn(x.size()){
        if (i == 0 || x[i] != x[i - 1]){
            cnt.push_back(1);
            val.push_back(x[i]);
        } else
            cnt.back()++;
    }
    if (val.size() != 3){
        cout << n << '\n';
        for (int i = 0; i < x.size(); ++i)
            cout << x[i] << ' ';
        return;
    }
    
    vll temp = cnt;
    ll d = 0;
    ll res;
    ll ansd = 0;
    while (temp[1] >= 2){
        temp[1] -= 2;
        temp[0]++;
        temp[2]++;
    }
    res = min(cnt[0], temp[0]) + min(cnt[1], temp[1]) + min(cnt[2], temp[2]);
    while (temp[0] && temp[2]){
        temp[1] += 2;
        temp[0]--, temp[2]--;
        d++;
        ll k = min(cnt[0], temp[0]) + min(cnt[1], temp[1]) + min(cnt[2], temp[2]);
        if (res > k){
            res = k;
            ansd = d;
        }
    }
    while (temp[1] >= 2){
        temp[1] -= 2;
        temp[0]++;
        temp[2]++;
    }
    forn(ansd){
       temp[1] += 2;
       temp[0]--, temp[2]--; 
    }
    cout << res << '\n';
    forn(temp[0])
        cout << val[0] << ' ';

    forn(temp[1])
        cout << val[1] << ' ';
    
    forn(temp[2])
        cout << val[2] << ' ';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifndef ONLINE_JUDGE
    freopen("input.in", "r", stdin);
    //freopen("output.out", "w", stdout);
#endif
    solve();
#ifndef ONLINE_JUDGE
    //cerr << fixed << setprecision(6) << (ld)clock() / CLOCKS_PER_SEC << '\n';
#endif
    return 0;
}

