#include "bits/stdc++.h"


#define pb push_back
#define mp make_pair
#define len(v) ((int)v.size())
#define mt make_tuple
#define f(i, n) for (int i = 0; i < (n); i++)


using namespace std;


typedef long long ll;
typedef pair<int, int> pii;

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

int n, m;
vector<int> opens;
vector<int> closes;
vector<int> v;

vector<int> mvp(vector<int> v) {
	vector<int> dp(len(v));
	dp[0] = 1;
	vector<int> kek(len(v) + 2, -1);
	kek[1] = 0;
	for (int i = 1; i < len(v); i++) {
		int left = 0;
		int right = len(kek);
		while (right - left > 1) {
			int mid = (left + right) / 2;
			if (kek[mid] == -1) {
				right = mid;
				continue;
			}
			if (v[kek[mid]] > v[i]) {
				right = mid;
			} else {
				left = mid;
			}
		}
		if (kek[left + 1] == -1 || v[kek[left + 1]] > v[i]) {
			kek[left + 1] = i;
		}
		dp[i] = left + 1;
	}
	return dp;
}

void run() {
	cin >> m >> n;
	opens.resize(n);
	closes.resize(n);
	v.resize(n);
	f(i, m) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		opens[l]++;
		closes[r]++;
	}
	int bal = 0;
	f(i, n) {
		bal += opens[i];
		v[i] = bal;
		bal -= closes[i];
	}
	for (int x : v) {
		//cout << x << " ";
	}
	//cout << endl;
	vector<int> left = mvp(v);
	vector<int> right;
	{
		vector<int> t = v;
		reverse(t.begin(), t.end());
		right = mvp(t);
		reverse(right.begin(), right.end());
	}
	{
		for (int p : left) {
			//cout << p << " ";
		}
		//cout << endl;
		for (int p : right) {
			//cout << p << " ";
		}
		//cout << endl;
	}
	{
		int best = 0;
		for (int i = 1; i < len(v); i++) {
			if (left[i] + right[i] > left[best] + right[best]) {
				best = i;
			}
		}
		cout << left[best] + right[best] - 1 << endl;
	}
}
