#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int) 1e9;

struct Graph {
    int n;
    vector<vector<int>> g;
    vector<int> cnt;

    void add(int f, int t) {
        g[f].push_back(t);
    }

    void dfs(int v, int h = 0) {
        cnt[h]++;
        for (auto to : g[v]) {
            dfs(to, h + 1);
        }
    }

    int get() {
        dfs(0);
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans += cnt[i] % 2;
        }
        return ans;
    }

    Graph(int n): n(n), g(n), cnt(n, 0) { }
};

int main() {
    #ifdef MY
        freopen("in.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(NULL);
    #endif // MY
    int n;
    cin >> n;
    Graph g(n);
    for (int i = 1, p; i < n; ++i) {
        cin >> p;
        g.add(p - 1, i);
    }
    cout << g.get() << "\n";
    return 0;
}
