#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
using namespace std;

// **  ** *****   ***** *    * ***  *   * *  *  * * 
// **  ** *           * *    * *  * *  ** *  *  * *
// ****** *****   ***** **** * ***  * * * *  *  * ***
//     ** *           * *  * * *    **  * *  *  * *  *
//     ** *****   ***** **** * *    *   * ******* ***

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int x;
	cin >> x;
	vector < int > v(x);
	for(int i = 0;i < x;i++)
		cin >> v[i];
	
	int shift = 1 <<20;

	sort(v.begin(),v.end());
	
	shift = v[0];
	for(int i = 0;i < x;i++){
		v[i] -= shift;
	}
	int a, b, c;
	a = b = c = 0;
	for(int i = 0;i < x;i++){
		if(v[i] == 0)
			a++;
		if(v[i] == 1)
			b++;
		if(v[i] == 2)
			c++;
	}
	int ans = 1e9;
	int A, B, C;
	A = B = C = 0;
	for(int na = 0;na <= x;na++){
		int nb = 2 * (a - na) + b;
		if(nb < 0)
			continue;
		int nc = x - na - nb;
		if(nc < 0)
			continue;

		if(c == 0 && nc != 0)
			continue;

		//cout << na << ' ' << nb << ' ' << nc << endl;
		int now = min(a, na) + min(b, nb) + min(c, nc);
		//cout << now << endl;
		if(ans > now){
			ans = now;
			A = na;
			B = nb;
			C = nc;
		}
	}
	cout << ans << endl;
	for(int i = 0;i < A;i++)
		cout << shift << ' ';
	for(int i = 0;i < B;i++)
		cout << shift + 1 << ' ';
	for(int i = 0;i < C;i++)
		cout << shift + 2 << ' ';
}