#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
using namespace std;

// **  ** *****   ***** *    * ***  *   * *  *  * * 
// **  ** *           * *    * *  * *  ** *  *  * *
// ****** *****   ***** **** * ***  * * * *  *  * ***
//     ** *           * *  * * *    **  * *  *  * *  *
//     ** *****   ***** **** * *    *   * ******* ***

const int len = 3e5;
vector < int > g[len];
int x;

int dep[len];

void dfs(int v, int d = 0){
	int sum = 0;
	dep[d]++;
	for(int i = 0;i < g[v].size();i++){
		int go = g[v][i];
		dfs(go, d + 1);
	}
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> x;
	for(int i = 0;i < x - 1;i++){
		int p;
		cin >> p;
		p--;
		g[p].push_back(i + 1);
	}
	int root = 0;
	dfs(root);
	int ans = 0;
	for(int i = 0;i < x + 1;i++){
		ans += dep[i] & 1;
	}
	cout << ans;
}