#include <bits/stdc++.h>

using namespace std;

bool get(vector<int> &prefMax, vector<int> &sufMax, vector<int> &field, int pos) {
    return field[pos] < prefMax[pos] && field[pos] < sufMax[pos];
}

const int INF = 1e9;

int findk(vector<int> field) {
    int n = field.size();
    vector<int> dp(n + 1, INF);
    dp[0] = 0;
    for (int i = 0; i < n; ++i) {
        int num = field[i];
        int pos = upper_bound(dp.begin(), dp.end(), num) - dp.begin();
//        for (auto x: dp) {
//            cout << x << " ";
//        }
//        cout << "\n";
        dp[pos] = min(dp[pos], num);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (dp[i] != INF) {
            ans = i;
        }
    }
    return ans;
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<int> field(m + 1, 0);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        field[l]++;
        field[r]--;
    }
    int now = 0;
    for (int i = 0; i < m; ++i) {
        now += field[i];
        field[i] = now;
    }
    int ans = findk(field);
    reverse(field.begin(), field.end());
    ans = max(ans, findk(field));
    cout << ans << "\n";
}
