//By Don4ick
#include <bits/stdc++.h>
#include <stdio.h>

typedef long long ll;

#define pb push_back
#define all(x) x.begin(), x.end()
#define y1 yq1231
#define forn(i, n) for (int i = 1; i <= n; i++)

const double PI = acos(-1.0);
const int DIR = 4;
const int X[] = {1, 0,-1, 0};
const int Y[] = {0, 1, 0, -1};

const int N = (int)1e5 + 228;

using namespace std;

map < int, bool > cnt[N];
int n;
vector < int > g[N];

void merge(int v, int u)
{
    if (cnt[v].size() > cnt[u].size())
    {
        cnt[u].swap(cnt[v]);        
    }
    for (auto it : cnt[v])
        cnt[u][it.first] ^= it.second;
}

void dfs(int v, int level)
{
    cnt[v][level] ^= 1;
    for (auto to : g[v])
    {
        dfs(to, level + 1);
        merge(to, v);
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie();
    //cout.tie(); 

    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);

    //~read
    scanf("%d", &n);
    for (int i = 2; i <= n; i++)
    {
        int pr;
        scanf("%d", &pr);
        g[pr].pb(i);
    }
    dfs(1, 0);
    int ans = 0;
    for (auto it : cnt[1])
    {
        ans += it.second;
    }
    cout << ans << endl;
    
    //cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;

    return 0;
}