#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <ctime>

using namespace std;
const int MAXN = 2e5 + 100;
const int INF = 1e9 + 100;

int n, m;
int mas[MAXN];
int kek[MAXN];

void f(vector<int>& vec){
    vector<int> np(m + 1, INF);
    np[0] = -INF;
    int cm = 0;
    for (int i = 0; i < m; ++i){
        int e = mas[i];
        int j = (upper_bound(np.begin(), np.end(), e) - np.begin());
        j--;

        np[j + 1] = min(np[j + 1], e);
        cm = max(cm, j + 1);
        vec[i] = cm;
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < n; ++i){
        int a, b;
        cin >> a >> b;
        kek[a - 1] += 1;
        kek[b] -= 1;
    }

    int cur = 0;
    for (int i = 0; i < m; ++i){
        cur += kek[i];
        mas[i] = cur;
    }

    vector<int> vec1(m);
    f(vec1);
    reverse(mas, mas + m);
    vector<int> vec2(m);
    f(vec2);
    reverse(vec2.begin(), vec2.end());
    /*for (int i = 0; i < m; ++i){
        cout << vec1[i] << ' ';
    }
    cout << endl;

    for (int i = 0; i < m; ++i){
        cout << vec2[i] << ' ';
    }
    cout << endl;*/

    vec2.push_back(0);

    int ans = 0;
    for (int i = 0; i < m; ++i){
        ans = max(ans, vec1[i] + vec2[i + 1]);
    }

    cout << ans << endl;

    return 0;
}
