#include<iostream>
#include<stdio.h>
#include<vector>
#include<string>
#include<stack>
#include<set>
#include<algorithm>
#include<cmath>
#include<map>


#define ll long long
#define pii pair<int,int>

using namespace std;

const int NMAX=111111;
const int inf =1E9;

int cnt[NMAX];
int dp1[NMAX];
int dp2[NMAX];
int t[4*NMAX];
void build(int v,int tl,int tr)
{
	if(tr==tl+1)
	{
		t[v]=0;
		return;
	}
	int m=(tl+tr)/2;
	build(2*v,tl,m);
	build(2*v+1,m,tr);
	t[v]=max(t[2*v],t[2*v+1]);
	return;
}
void updata(int v,int tl,int tr,int pos,int data)
{
	if(tl>pos||tr<=pos)
		return;
	if(tr==tl+1)
	{
		t[v]=max(data,t[v]);
		return;
	}
	int m=(tl+tr)/2;
	updata(2*v,tl,m,pos,data);
	updata(2*v+1,m,tr,pos,data);
	t[v]=max(t[2*v],t[2*v+1]);
	return;
}
int get(int v,int tl,int tr,int l,int r)
{
	if(tl>=r||tr<=l)
		return 0;
	if(tl==l&&tr==r)
		return t[v];
	int m=(tl+tr)/2;
	return max(get(2*v,tl,m,l,min(r,m)),get(2*v+1,m,tr,max(l,m),r));
}
int main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	int n,m;
	cin>>n>>m;
	for(int i=1;i<=n;i++)
	{
		int l,r;
		cin>>l>>r;
		cnt[l]++;
		cnt[r+1]--;
	}
	int s=0;
	for(int i=1;i<=m;i++)
	{
		s+=cnt[i];
		cnt[i]=s;
	}
	build(1,0,n+1);
	for(int i=1;i<=m;i++)
	{
		dp1[i]=get(1,0,n+1,0,cnt[i]+1)+1;
		updata(1,0,n+1,cnt[i],dp1[i]);
	}
	build(1,0,n+1);
	for(int i=m;i>=1;i--)
	{
		dp2[i]=get(1,0,n+1,0,cnt[i]+1)+1;
		updata(1,0,n+1,cnt[i],dp2[i]);
	}
	int ans=0;
	for(int i=1;i<=m;i++)
	{
		ans=max(ans,dp1[i]+dp2[i]-1);
	}
	cout<<ans;
	return 0;
}