#include <bits/stdc++.h>

using namespace std;

//#define int int64_t
#define endl '\n'
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (int i = 0; i < (int)arr.size() - 1; ++i)
        out << arr[i] << " ";
    if (arr.size())
        out << arr.back() << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

vector <vector <int> > g;
vector <int> h;

void dfs(int v, int hn = 0, int p = -1) {
    h[hn]++;
    for (auto x : g[v]) {
        if (x == p)
            continue;
        dfs(x, hn + 1, v);
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int l;
    string s;
    cin >> s;
    l = s.size();
    vector <vector <string> > arr(26);
    for (int i = 0; i < l; ++i) {
        string s2 = s;
        reverse(s2.begin(), s2.begin() + i);
        reverse(s2.begin() + i, s2.end());
        reverse(s2.begin(), s2.end());
        arr[s2[0] - 'a'].push_back(s2);
    }
    int ans = 0;
    vector <vector <vector <int> > > pod(26, vector <vector <int> > (l, vector <int> (26, 0)));
    for (int i = 0; i < 26; ++i) {
        for (int j = 0; j < arr[i].size(); ++j) {
            for (int k = 0; k < l; ++k) {
                pod[i][k][arr[i][j][k] - 'a']++;
            }
        }
    }
    for (int i = 0; i < 26; ++i) {
        if (arr[i].size() == 1)
        {
            ans++;
            continue;
        }
        int mx = 0;
        for (int j = 1; j < l; ++j) {
            int now = 0;
            for (int k = 0; k < 26; ++k) {
                now += (pod[i][j][k] == 1);
            }
            mx = max(mx, now);
        }
        ans += mx;
    }
    cout << (double)ans / l << endl;
    return 0;
}
