#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define endl '\n'
#define fi first
#define se second
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (int i = 0; i < (int)arr.size() - 1; ++i)
        out << arr[i] << " ";
    if (arr.size())
        out << arr.back() << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

const int INF = 1000000000000000000;

int gett(int l, int r) {
    int len = r - l;
    if (len % 2 == 0) {
        return (l % 2 == 0) + len / 2;
    }
    else
        return (len + 1) / 2;
}

int solve(vector <pair <int, int> > arr) {
    if (arr.size() == 0)
        return 0;
    bool ch = (arr[0].fi % 2 == 0);
    int n = arr.size();
    vector <int> smn(n + 1, INF), smx(n + 1, -INF);
    for (int i = 0; i < n; ++i){
        smn[i + 1] = min(smn[i], arr[n - i - 1].se);
        smx[i + 1] = max(smx[i], arr[n - i - 1].se);
    }
    int mn = INF;
    int mx = -INF;
    int ans = 0;
    //cout << "smx = " << smx << endl;
    //cout << "xmn = " << smn << endl;
    for (int i = 0; i < n - 1; ++i) {

        mn = min(mn, arr[i].se);
        mx = max(mx, arr[i].se);
        int l = max(mn, smn[n - i - 1]);
        int r = min(mx, smx[n - i - 1]);
        //cout << "l, r = " << l << r << endl;
        if (r < l)
            continue;
        if (ch) {
            ans += (r - l + 1 - gett(l, r)) * (arr[i + 1].fi - arr[i].fi + 1 - gett(arr[i].fi, arr[i + 1].fi));
        }
        else {
            ans += gett(l, r) * gett(arr[i].fi, arr[i + 1].fi);
        }
    }
    return ans;
}


signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <pair <int, int> > arr(n);
    cin >> arr;
    vector <pair <int, int> > ch, nch;
    for (auto x : arr) {
        if ((x.fi + x.se) % 2 == 0)
        {
            ch.push_back(mp(x.fi + x.se, x.fi - x.se));
        }
        else {
            nch.push_back(mp(x.fi + x.se, x.fi - x.se));
        }
    }
    sort(ch.begin(), ch.end());
    sort(nch.begin(), nch.end());


    //cout << "ch = " << ch << endl;
    //cout << "nch = " << nch << endl;
    cout << solve(ch) + solve(nch) << endl;
    return 0;
}


