import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    ArrayList<ArrayList<Integer>> q;
    boolean[] used;

    public void solve() throws IOException {
        int n = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        int min = a[0];
        int max = a[0];
        for (int i = 0; i < n; i++) {
            if (a[i] > max) {
                max = a[i];
            }
            if (a[i] < min) {
                min = a[i];
            }
        }
        int b1 = 0;
        int b2 = 0;
        int b3 = 0;
        if (min == max) {
            out.println(n);
            for (int i = 0; i < n; i++) {
                out.print(a[i] + " ");
            }
            return;
        }
        for (int i = 0; i < n; i++) {
            if (a[i] == min) {
                b1++;
            } else {
                if (a[i] == max) {
                    b3++;
                } else {
                    b2++;
                }
            }
        }

        if (max == min + 1){
            out.println(n);
            for (int i = 0; i < n; i++) {
                out.print(a[i] + " ");
            }
            return;
        }
       if (2 * Math.min(b1,b3) >= (b2 - (b2 % 2))){
            int z1 = Math.min(b1,b3);
            int z2 = z1;
            out.println(n - 2 * Math.min(b1,b3));
           for (int i = 0; i < n; i++) {
               if (a[i] == min && z1 > 0){
                   z1--;
                   a[i]++;
               }else {
                   if (a[i] == max && z2 > 0){
                       z2--;
                       a[i]--;
                   }
               }
           }
       }else {
           out.println(n - (b2 - (b2 % 2)));
           int z1 = ((b2 - (b2 % 2))) / 2;
           int z2 = (b2 - (b2 % 2)) / 2;
           for (int i = 0; i < n; i++) {
               if (a[i] == min + 1){
                   if (z1 > 0){
                       a[i]++;
                       z1--;
                   }else {
                       if (z2 > 0){
                           a[i]--;
                           z2--;
                       }
                   }
               }
           }
       }
        for (int i = 0; i < n; i++) {
            out.print(a[i] + " ");
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
