import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class Main {
    ArrayList<ArrayList<Integer>> q;
    boolean[] used;

    public void solve() throws IOException {
        String s = nextToken();
        ArrayList<ArrayList<Integer>> a = new ArrayList<>();
        TreeMap<Integer, Integer> b = new TreeMap<>();
        for (int i = 0; i < s.length(); i++) {
            if (!b.containsKey(s.charAt(i) - 'a')) {
                b.put(s.charAt(i) - 'a', a.size());
                a.add(new ArrayList<>());
            }
            a.get(b.get(s.charAt(i) - 'a')).add(i);
        }
        double x = 0;
        int[][][] y = new int[26][26][s.length()];
        for (int i = 0; i < s.length(); i++) {
            for (int j = 0; j < s.length(); j++) {
                y[s.charAt(i) - 'a'][s.charAt((i + j) % s.length()) - 'a'][j]++;
            }
        }
        for (int i = 0; i < a.size(); i++) {
            int a1 = s.charAt(a.get(i).get(0)) - 'a';
            int max = 0;
            for (int j = 0; j < s.length(); j++) {
               int max1 = 0;
                for (int k = 0; k < 26; k++) {
                    if (y[a1][k][j] == 1){
                        max1++;
                    }
                }
                if (max1 > max){
                    max = max1;
                }
            }
            x += (double)max;
        }
        out.print((double) x / s.length());
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
