#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second

const int maxn = 5010;
int cnt[maxn][26];

int kol[26];

vector<int> shifts[30];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    string s;
    cin >> s;
    const int n = s.size();
    for (int i = 0; i < n; ++i) {
        shifts[s[i] - 'a'].push_back(i);
        kol[s[i] - 'a']++;
    }

    ld sum = 0.0;
    for (int c = 0; c < 26; ++c) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < 26; ++j) {
                cnt[i][j] = 0;
            }
        }

        if (shifts[c].size() == 0)
            continue;

        for (int shift : shifts[c]) {
            int i = shift + 1;
            if (i == n) i = 0;
            int pos = 1;
            while (i != shift) {
                cnt[pos][s[i] - 'a']++;
                i++;
                pos++;
                if (i == n)
                    i = 0;
            }
        }

        ld best = 0.0;
        for (int i = 1; i < n; ++i) {
            ld x = 0.0;
            ld y = 0.0;
            for (int j = 0; j < 26; ++j) {
                if (cnt[i][j] == 1) x += 1.0;
                if (cnt[i][j] != 0) y += (ld)cnt[i][j];
            }
            best = max(best, x / y);
        }

        sum += best * (ld)(kol[c]) / ld(n);
    }

    cout << fixed << setprecision(12) << sum << endl;
    return 0;
}
