#include<iostream>
#include<string>
#include<math.h>
#include<vector>
#include<algorithm>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<time.h>

using namespace std;

/*
Дорога к топу
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
															^(0,0)^ ^(0,0)^ ^(0,0)^
														^(0,0)^ ^(0,0)^ ^(0,0)^
													^(0,0)^ ^(0,0)^ ^(0,0)^
												^(0,0)^ ^(0,0)^ ^(0,0)^
											^(0,0)^ ^(0,0)^ ^(0,0)^
										^(0,0)^ ^(0,0)^ ^(0,0)^
									^(0,0)^ ^(0,0)^ ^(0,0)^
								^(0,0)^ ^(0,0)^ ^(0,0)^
							^(0,0)^ ^(0,0)^ ^(0,0)^
						^(0,0)^ ^(0,0)^ ^(0,0)^
					^(0,0)^ ^(0,0)^ ^(0,0)^
				^(0,0)^ ^(0,0)^ ^(0,0)^
			^(0,0)^ ^(0,0)^ ^(0,0)^
		^(0,0)^ ^(0,0)^ ^(0,0)^
	^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^
^(0,0)^ ^(0,0)^ ^(0,0)^

*/

const int maxn = 1e5 + 113;
vector<int> gr[maxn];
int ans[maxn];

void dfs(int v, int t)
{
	ans[t]++;
	for(int i = 0; i < gr[v].size(); i++)
		dfs(gr[v][i], t + 1);
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.precision(3);
	cout.setf(ios::fixed);
	int n;
	cin >> n;
	for(int i = 2; i <= n; i++)
	{
		int a;
		cin >> a;
		gr[a].push_back(i);
	}
	dfs(1, 0);
	long long anse = 0;
	for(int i = 0; i <= n; i++)
		if(ans[i] % 2 == 1)
			anse++;
	cout << anse;
}
