#include <bits/stdc++.h>
using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    int mn = 1000000000;
    vector<int> x(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i];
        mn = min(mn, x[i]);
    }
    for (int i = 0; i < n; i++) {
        x[i] -= mn;
    }
    int a = 0, b = 0, c = 0;
    for (int i : x) {
        if (i == 0) a++;
        if (i == 1) b++;
        if (i == 2) c++;
    }

    if (c > 0) {
        int best = n;
        int bd = a, be = b, bf = c;
        for (int f = 0; f <= n; f++) {
            // b + 2c = e + 2f
            // e = b + 2c - 2f
            int e = b + 2 * c - 2 * f;
            int d = n - e - f;
            if (0 <= d && d <= n && 0 <= e && e <= n && 0 <= f && f <= n && d + e + f == n) {
                int cost = min(a, d) + min(b, e) + min(c, f);
                if (cost < best) {
                    best = cost;
                    bd = d;
                    be = e;
                    bf = f;
                }
            }
        }

        cout << best << endl;
        for (int i = 0; i < bd; i++) {
            cout << mn << " ";
        }
        for (int i = 0; i < be; i++) {
            cout << mn + 1 << " ";
        }
        for (int i = 0; i < bf; i++) {
            cout << mn + 2 << " ";
        }
    } else {
        int best = n;
        int bd = a, be = b, bf = c;
        for (int f = 0; f <= 0; f++) {
            // b + 2c = e + 2f
            // e = b + 2c - 2f
            int e = b + 2 * c - 2 * f;
            int d = n - e - f;
            if (0 <= d && d <= n && 0 <= e && e <= n && 0 <= f && f <= n && d + e + f == n) {
                int cost = min(a, d) + min(b, e) + min(c, f);
                if (cost < best) {
                    best = cost;
                    bd = d;
                    be = e;
                    bf = f;
                }
            }
        }

        cout << best << endl;
        for (int i = 0; i < bd; i++) {
            cout << mn << " ";
        }
        for (int i = 0; i < be; i++) {
            cout << mn + 1 << " ";
        }
        for (int i = 0; i < bf; i++) {
            cout << mn + 2 << " ";
        }
    }

    return 0;
}