#include <bits/stdc++.h>
using namespace std;

const int INF = 1000000000;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<int> l(n), r(n);
    vector<int> a(m + 1);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        l[i]--;
        r[i]--;
        a[l[i]]++;
        a[r[i] + 1]--;
    }
    for (int i = 1; i <= m; i++) {
        a[i] += a[i - 1];
    }

    vector<int> b1(m), b2(m);

    vector<int> mnv(m + 1, INF);
    mnv[0] = -1;
    for (int i = 0; i < m; i++) {
        int L = 0;
        int R = m;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (mnv[M] <= a[i]) {
                L = M;
            } else {
                R = M;
            }
        }
        b1[i] = L + 1;
        mnv[L + 1] = min(mnv[L + 1], a[i]);
    }

    mnv.assign(m + 1, INF);
    mnv[0] = -1;
    for (int i = m - 1; i >= 0; i--) {
        int L = 0;
        int R = m;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (mnv[M] <= a[i]) {
                L = M;
            } else {
                R = M;
            }
        }
        b2[i]= L + 1;
        mnv[L + 1] = min(mnv[L + 1], a[i]);
    }

    int mx = 0;
    for (int i = 0; i < m; i++) {
        mx = max(mx, b1[i] + b2[i] - 1);
    }

    cout << mx << endl;

    return 0;
}
