#include <bits/stdc++.h>


#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define mp make_pair
#define pb push_back


bool deb = 1;
#define pas(x) if (deb) cout << #x << " " << x << endl; 

using namespace std;

struct stree {
    vector<ll> t;
    int k;
    stree(int n) {
        k = 1;
        while (k <= n) k *= 2;
        t.assign(2 * k, 0);
    }

    ll get(int l, int r) {
        ll res = 0;
        for (l += k, r += k; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) res = max(res, t[l++]);
            if (r % 2 == 0) res = max(res, t[r--]);
        }
        return res;
    }

    void update(int pos, ll val) {
        pos += k;
        while (pos > 0) {
            if (pos >= k)
                t[pos] = val;
            else
                t[pos] = max(t[2 * pos], t[2 * pos + 1]);
            pos /= 2;
        }
    }
};

void nvp(vector<ll> &arr, vector<int> &res) {
    int m = arr.size();
    res[0] = 1;

    vector<pll> vals;
    for (int i = 0; i < m; i++) {
        vals.pb(mp(arr[i], i));
    }
    sort(vals.begin(), vals.end());
    stree st(m);
    for (int i = 0; i < m; i++) {
        pll p = vals[i];
        ll v, pos;
        tie(v, pos) = p;
        // cout << v << ' ' << pos << endl;
        res[pos] = st.get(0, pos - 1) + 1;
        st.update(pos, res[pos]);
    }
}

int main() {
    cout.precision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<ll> plus(m + 1);
    vector<ll> arr(m);

    for (int i = 0; i < n; i++){
        ll l, r; cin >> l >> r;
        l--;
        plus[l]++;
        plus[r]--;
    }
    ll cur = 0;
    for (int i = 0; i < m; i++) {
        cur += plus[i];
        arr[i] = cur;    
    }

    ll mx = 0;
    for (int i = 0; i < m; i++) {
        if (mx < arr[i]) mx = arr[i];
    }

    if (mx == n) {
        cout << m - 1 << endl;
        return 0;
    }

    vector<int> a1(m);
    nvp(arr, a1);
    // for (ll i : arr) cout << i << ' ';
    // cout << endl;
    // for (int i : a1) cout << i << ' ';

    reverse(arr.begin(), arr.end());
    vector<int> a2(m);
    nvp(arr, a2);
    // for (int i = 0; i < m; i++) cout << a2[i] << ' ';
    // cout << endl;
    // for (int i = 0; i < m; i++) cout << a1[i] << ' ';
    // cout << endl;

    int res = 0;
    for (int i = 0; i < m; i++) res = max(res, a1[i] + a2[m - i - 1] - 1);
    cout << res << endl;


    return 0;
}