#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int INF = 2e9;
const int N = 100105;
int dp[N][2];
int a[N];

int t[4 * N][2];

void setmx(int v, int vl, int vr, int pos, int val, int j) {
    if (vl == vr) {
        chkmax(t[v][j], val);
        return;
    }

    int vm = (vl + vr) >> 1;
    if (pos <= vm) {
        setmx(v + v, vl, vm, pos, val, j);
    } else {
        setmx(v + v + 1, vm + 1, vr, pos, val, j);
    }
    t[v][j] = max(t[v + v][j], t[v + v + 1][j]);
}

int get(int v, int vl, int vr, int l, int r, int j) {
    if (l > r)
        return -INF;
    if (vl == l && vr == r)
        return t[v][j];

    int vm = (vl + vr) >> 1;
    return max(
        get(v + v, vl, vm, l, min(vm, r), j),
        get(v + v + 1, vm + 1, vr, max(vm + 1, l), r, j)
    );
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);

    int m, n;
    cin >> m >> n;
    rep(i, m) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        a[l]++;
        if (r < n - 1) a[r + 1]--;
    }

    rep(i, n) {
        if (i) a[i] += a[i - 1];
    }

    int ans = 0;
    rep(i, n) {
        // down
        dp[i][0] = get(1, 0, N - 1, 0, a[i], 0) + 1;

        // up
        dp[i][1] = dp[i][0];
        chkmax(dp[i][1], get(1, 0, N - 1, a[i], N - 1, 1));

        setmx(1, 0, N - 1, a[i], dp[i][0], 0);
        setmx(1, 0, N - 1, a[i], dp[i][1], 1);
        chkmax(ans, dp[i][0]);
        chkmax(ans, dp[i][1]);
    }
    cout << ans << endl;



    return 0;
}
